# Projects

Interactions with projects

## Get a list of projects

> List projects and their inboxes to which the API token has access.

```json
{"openapi":"3.1.0","info":{"title":"Email Sandbox","version":"2.0.0"},"tags":[{"name":"Projects","description":"Interactions with projects"}],"servers":[{"description":"Mailtrap API","url":"https://mailtrap.io"}],"security":[{"HeaderAuth":[]},{"BearerAuth":[]}],"components":{"securitySchemes":{"HeaderAuth":{"type":"apiKey","description":"Pass the API token in the Api-Token","in":"header","name":"Api-Token"},"BearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"responses":{"ProjectsResponse":{"description":"Lists project attributes and inboxes of this project with their attributes.\n- **permissions** returns the permissions of the token for the project","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Project"}}}}},"UNAUTHENTICATED":{"description":"Returns unauthorized error message. Check your credentials.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/UnauthenticatedResponse"}}}},"PERMISSION_DENIED":{"description":"Returns forbidden error message. Check your permissions.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PermissionsDeniedResponse"}}}}},"schemas":{"Project":{"title":"Testing Project","type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"share_links":{"type":"object","properties":{"admin":{"type":"string"},"viewer":{"type":"string"}}},"inboxes":{"type":"array","items":{"nullable":true,"$ref":"#/components/schemas/TestingInbox"}},"permissions":{"type":"object","properties":{"can_read":{"type":"boolean"},"can_update":{"type":"boolean"},"can_destroy":{"type":"boolean"},"can_leave":{"type":"boolean"}}}}},"TestingInbox":{"title":"Testing Inbox","type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"username":{"type":"string"},"password":{"type":"string","nullable":true,"description":"Password is only available if you have admin permissions for the inbox."},"max_size":{"type":"integer"},"status":{"type":"string","enum":["active","inactive","pending"]},"email_username":{"type":"string"},"email_username_enabled":{"type":"boolean"},"sent_messages_count":{"type":"integer"},"forwarded_messages_count":{"type":"integer"},"used":{"type":"boolean"},"forward_from_email_address":{"type":"string"},"project_id":{"type":"integer"},"domain":{"type":"string"},"pop3_domain":{"type":"string"},"email_domain":{"type":"string"},"api_domain":{"type":"string"},"emails_count":{"type":"integer"},"emails_unread_count":{"type":"integer"},"last_message_sent_at":{"nullable":true,"type":"string"},"smtp_ports":{"type":"array","items":{"type":"integer"}},"pop3_ports":{"type":"array","items":{"type":"integer"}},"max_message_size":{"type":"integer"},"permissions":{"type":"object","properties":{"can_read":{"type":"boolean"},"can_update":{"type":"boolean"},"can_destroy":{"type":"boolean"},"can_leave":{"type":"boolean"}}}}},"UnauthenticatedResponse":{"title":"UnauthenticatedResponse","type":"object","properties":{"error":{"type":"string","description":"Error message"}}},"PermissionsDeniedResponse":{"title":"PermissionsDeniedResponse","type":"object","properties":{"errors":{"type":"string","description":"Error message"}}}}},"paths":{"/api/accounts/{account_id}/projects":{"get":{"summary":"Get a list of projects","description":"List projects and their inboxes to which the API token has access.","tags":["Projects"],"responses":{"200":{"$ref":"#/components/responses/ProjectsResponse"},"401":{"$ref":"#/components/responses/UNAUTHENTICATED"},"403":{"$ref":"#/components/responses/PERMISSION_DENIED"}},"operationId":"getProjects"}}}}
```

## Create project

> The project name is min 2 characters and max 100 characters long.

```json
{"openapi":"3.1.0","info":{"title":"Email Sandbox","version":"2.0.0"},"tags":[{"name":"Projects","description":"Interactions with projects"}],"servers":[{"description":"Mailtrap API","url":"https://mailtrap.io"}],"security":[{"HeaderAuth":[]},{"BearerAuth":[]}],"components":{"securitySchemes":{"HeaderAuth":{"type":"apiKey","description":"Pass the API token in the Api-Token","in":"header","name":"Api-Token"},"BearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"responses":{"ProjectResponse":{"description":"Returns project details","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Project"}}}},"UNAUTHENTICATED":{"description":"Returns unauthorized error message. Check your credentials.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/UnauthenticatedResponse"}}}},"PERMISSION_DENIED":{"description":"Returns forbidden error message. Check your permissions.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PermissionsDeniedResponse"}}}}},"schemas":{"Project":{"title":"Testing Project","type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"share_links":{"type":"object","properties":{"admin":{"type":"string"},"viewer":{"type":"string"}}},"inboxes":{"type":"array","items":{"nullable":true,"$ref":"#/components/schemas/TestingInbox"}},"permissions":{"type":"object","properties":{"can_read":{"type":"boolean"},"can_update":{"type":"boolean"},"can_destroy":{"type":"boolean"},"can_leave":{"type":"boolean"}}}}},"TestingInbox":{"title":"Testing Inbox","type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"username":{"type":"string"},"password":{"type":"string","nullable":true,"description":"Password is only available if you have admin permissions for the inbox."},"max_size":{"type":"integer"},"status":{"type":"string","enum":["active","inactive","pending"]},"email_username":{"type":"string"},"email_username_enabled":{"type":"boolean"},"sent_messages_count":{"type":"integer"},"forwarded_messages_count":{"type":"integer"},"used":{"type":"boolean"},"forward_from_email_address":{"type":"string"},"project_id":{"type":"integer"},"domain":{"type":"string"},"pop3_domain":{"type":"string"},"email_domain":{"type":"string"},"api_domain":{"type":"string"},"emails_count":{"type":"integer"},"emails_unread_count":{"type":"integer"},"last_message_sent_at":{"nullable":true,"type":"string"},"smtp_ports":{"type":"array","items":{"type":"integer"}},"pop3_ports":{"type":"array","items":{"type":"integer"}},"max_message_size":{"type":"integer"},"permissions":{"type":"object","properties":{"can_read":{"type":"boolean"},"can_update":{"type":"boolean"},"can_destroy":{"type":"boolean"},"can_leave":{"type":"boolean"}}}}},"UnauthenticatedResponse":{"title":"UnauthenticatedResponse","type":"object","properties":{"error":{"type":"string","description":"Error message"}}},"PermissionsDeniedResponse":{"title":"PermissionsDeniedResponse","type":"object","properties":{"errors":{"type":"string","description":"Error message"}}}}},"paths":{"/api/accounts/{account_id}/projects":{"post":{"summary":"Create project","description":"The project name is min 2 characters and max 100 characters long.","tags":["Projects"],"requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"project":{"type":"object","properties":{"name":{"type":"string"}}}}}}}},"responses":{"200":{"$ref":"#/components/responses/ProjectResponse"},"401":{"$ref":"#/components/responses/UNAUTHENTICATED"},"403":{"$ref":"#/components/responses/PERMISSION_DENIED"}},"operationId":"createProject"}}}}
```

## Get project by ID

> Get the project and its inboxes.

```json
{"openapi":"3.1.0","info":{"title":"Email Sandbox","version":"2.0.0"},"tags":[{"name":"Projects","description":"Interactions with projects"}],"servers":[{"description":"Mailtrap API","url":"https://mailtrap.io"}],"security":[{"HeaderAuth":[]},{"BearerAuth":[]}],"components":{"securitySchemes":{"HeaderAuth":{"type":"apiKey","description":"Pass the API token in the Api-Token","in":"header","name":"Api-Token"},"BearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"responses":{"ProjectResponse":{"description":"Returns project details","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Project"}}}},"UNAUTHENTICATED":{"description":"Returns unauthorized error message. Check your credentials.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/UnauthenticatedResponse"}}}},"PERMISSION_DENIED":{"description":"Returns forbidden error message. Check your permissions.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PermissionsDeniedResponse"}}}},"NOT_FOUND":{"description":"Returns not found error message","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFoundResponse"}}}}},"schemas":{"Project":{"title":"Testing Project","type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"share_links":{"type":"object","properties":{"admin":{"type":"string"},"viewer":{"type":"string"}}},"inboxes":{"type":"array","items":{"nullable":true,"$ref":"#/components/schemas/TestingInbox"}},"permissions":{"type":"object","properties":{"can_read":{"type":"boolean"},"can_update":{"type":"boolean"},"can_destroy":{"type":"boolean"},"can_leave":{"type":"boolean"}}}}},"TestingInbox":{"title":"Testing Inbox","type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"username":{"type":"string"},"password":{"type":"string","nullable":true,"description":"Password is only available if you have admin permissions for the inbox."},"max_size":{"type":"integer"},"status":{"type":"string","enum":["active","inactive","pending"]},"email_username":{"type":"string"},"email_username_enabled":{"type":"boolean"},"sent_messages_count":{"type":"integer"},"forwarded_messages_count":{"type":"integer"},"used":{"type":"boolean"},"forward_from_email_address":{"type":"string"},"project_id":{"type":"integer"},"domain":{"type":"string"},"pop3_domain":{"type":"string"},"email_domain":{"type":"string"},"api_domain":{"type":"string"},"emails_count":{"type":"integer"},"emails_unread_count":{"type":"integer"},"last_message_sent_at":{"nullable":true,"type":"string"},"smtp_ports":{"type":"array","items":{"type":"integer"}},"pop3_ports":{"type":"array","items":{"type":"integer"}},"max_message_size":{"type":"integer"},"permissions":{"type":"object","properties":{"can_read":{"type":"boolean"},"can_update":{"type":"boolean"},"can_destroy":{"type":"boolean"},"can_leave":{"type":"boolean"}}}}},"UnauthenticatedResponse":{"title":"UnauthenticatedResponse","type":"object","properties":{"error":{"type":"string","description":"Error message"}}},"PermissionsDeniedResponse":{"title":"PermissionsDeniedResponse","type":"object","properties":{"errors":{"type":"string","description":"Error message"}}},"NotFoundResponse":{"title":"NotFoundResponse","type":"object","properties":{"error":{"type":"string","description":"Error message"}}}}},"paths":{"/api/accounts/{account_id}/projects/{project_id}":{"get":{"summary":"Get project by ID","description":"Get the project and its inboxes.","tags":["Projects"],"responses":{"200":{"$ref":"#/components/responses/ProjectResponse"},"401":{"$ref":"#/components/responses/UNAUTHENTICATED"},"403":{"$ref":"#/components/responses/PERMISSION_DENIED"},"404":{"$ref":"#/components/responses/NOT_FOUND"}},"operationId":"getProject"}}}}
```

## Delete project

> Delete project and its inboxes.

```json
{"openapi":"3.1.0","info":{"title":"Email Sandbox","version":"2.0.0"},"tags":[{"name":"Projects","description":"Interactions with projects"}],"servers":[{"description":"Mailtrap API","url":"https://mailtrap.io"}],"security":[{"HeaderAuth":[]},{"BearerAuth":[]}],"components":{"securitySchemes":{"HeaderAuth":{"type":"apiKey","description":"Pass the API token in the Api-Token","in":"header","name":"Api-Token"},"BearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"responses":{"UNAUTHENTICATED":{"description":"Returns unauthorized error message. Check your credentials.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/UnauthenticatedResponse"}}}},"PERMISSION_DENIED":{"description":"Returns forbidden error message. Check your permissions.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PermissionsDeniedResponse"}}}},"NOT_FOUND":{"description":"Returns not found error message","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFoundResponse"}}}}},"schemas":{"UnauthenticatedResponse":{"title":"UnauthenticatedResponse","type":"object","properties":{"error":{"type":"string","description":"Error message"}}},"PermissionsDeniedResponse":{"title":"PermissionsDeniedResponse","type":"object","properties":{"errors":{"type":"string","description":"Error message"}}},"NotFoundResponse":{"title":"NotFoundResponse","type":"object","properties":{"error":{"type":"string","description":"Error message"}}}}},"paths":{"/api/accounts/{account_id}/projects/{project_id}":{"delete":{"summary":"Delete project","description":"Delete project and its inboxes.","tags":["Projects"],"responses":{"200":{"description":"Returns id of the deleted project.","content":{"application/json":{"schema":{"type":"object","properties":{"id":{"type":"integer"}}}}}},"401":{"$ref":"#/components/responses/UNAUTHENTICATED"},"403":{"$ref":"#/components/responses/PERMISSION_DENIED"},"404":{"$ref":"#/components/responses/NOT_FOUND"}},"operationId":"deleteProject"}}}}
```

## Update project

> Update project name. The project name is min 2 characters and max 100 characters long.

```json
{"openapi":"3.1.0","info":{"title":"Email Sandbox","version":"2.0.0"},"tags":[{"name":"Projects","description":"Interactions with projects"}],"servers":[{"description":"Mailtrap API","url":"https://mailtrap.io"}],"security":[{"HeaderAuth":[]},{"BearerAuth":[]}],"components":{"securitySchemes":{"HeaderAuth":{"type":"apiKey","description":"Pass the API token in the Api-Token","in":"header","name":"Api-Token"},"BearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"responses":{"UpdateProjectResponse":{"description":"Returns updated project details","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Project"}}}},"UNAUTHENTICATED":{"description":"Returns unauthorized error message. Check your credentials.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/UnauthenticatedResponse"}}}},"PERMISSION_DENIED":{"description":"Returns forbidden error message. Check your permissions.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PermissionsDeniedResponse"}}}},"NOT_FOUND":{"description":"Returns not found error message","content":{"application/json":{"schema":{"$ref":"#/components/schemas/NotFoundResponse"}}}}},"schemas":{"Project":{"title":"Testing Project","type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"share_links":{"type":"object","properties":{"admin":{"type":"string"},"viewer":{"type":"string"}}},"inboxes":{"type":"array","items":{"nullable":true,"$ref":"#/components/schemas/TestingInbox"}},"permissions":{"type":"object","properties":{"can_read":{"type":"boolean"},"can_update":{"type":"boolean"},"can_destroy":{"type":"boolean"},"can_leave":{"type":"boolean"}}}}},"TestingInbox":{"title":"Testing Inbox","type":"object","properties":{"id":{"type":"integer"},"name":{"type":"string"},"username":{"type":"string"},"password":{"type":"string","nullable":true,"description":"Password is only available if you have admin permissions for the inbox."},"max_size":{"type":"integer"},"status":{"type":"string","enum":["active","inactive","pending"]},"email_username":{"type":"string"},"email_username_enabled":{"type":"boolean"},"sent_messages_count":{"type":"integer"},"forwarded_messages_count":{"type":"integer"},"used":{"type":"boolean"},"forward_from_email_address":{"type":"string"},"project_id":{"type":"integer"},"domain":{"type":"string"},"pop3_domain":{"type":"string"},"email_domain":{"type":"string"},"api_domain":{"type":"string"},"emails_count":{"type":"integer"},"emails_unread_count":{"type":"integer"},"last_message_sent_at":{"nullable":true,"type":"string"},"smtp_ports":{"type":"array","items":{"type":"integer"}},"pop3_ports":{"type":"array","items":{"type":"integer"}},"max_message_size":{"type":"integer"},"permissions":{"type":"object","properties":{"can_read":{"type":"boolean"},"can_update":{"type":"boolean"},"can_destroy":{"type":"boolean"},"can_leave":{"type":"boolean"}}}}},"UnauthenticatedResponse":{"title":"UnauthenticatedResponse","type":"object","properties":{"error":{"type":"string","description":"Error message"}}},"PermissionsDeniedResponse":{"title":"PermissionsDeniedResponse","type":"object","properties":{"errors":{"type":"string","description":"Error message"}}},"NotFoundResponse":{"title":"NotFoundResponse","type":"object","properties":{"error":{"type":"string","description":"Error message"}}}}},"paths":{"/api/accounts/{account_id}/projects/{project_id}":{"patch":{"summary":"Update project","description":"Update project name. The project name is min 2 characters and max 100 characters long.","tags":["Projects"],"requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"project":{"type":"object","properties":{"name":{"type":"string"}}}}}}}},"responses":{"200":{"$ref":"#/components/responses/UpdateProjectResponse"},"401":{"$ref":"#/components/responses/UNAUTHENTICATED"},"403":{"$ref":"#/components/responses/PERMISSION_DENIED"},"404":{"$ref":"#/components/responses/NOT_FOUND"}},"operationId":"updateProject"}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.mailtrap.io/developers/email-sandbox/projects.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
